/*
	BR Tools
	Created by Benedikt Rey
	26.02.2013
	v1.0
	BeneRey@gmx.de
*/


struct TheMeshSizeStuff (obj, height, width, depth)
TheMesh = TheMeshSizeStuff ()
fn UpdateTheMesh = ()
rollout ResizeAfterZBrush "Resize after using ZBrush" width:170 --height:165
(
	label lblCM "... all size in cm ..."
	label lblText "Current Obj: "
	label lblCurrentSize "Current size: "
	
	checkbox chkZ pos:[5,65] checked:true
	checkbox chkY pos:[5,chkZ.pos.y+20] checked:false
	checkbox chkX pos:[5,chkZ.pos.y+40] checked:false

	spinner spnTrueSizeZ "New Size Z:" pos:[30,chkZ.pos.y] range:[1,1000,165] enabled:chkZ.checked tooltip:"1.65m is the size of Zia, the Main Character!"
	spinner spnTrueSizeY "New Size Y:" pos:[30,chkY.pos.y] range:[1,1000,100] enabled:chkY.checked
	spinner spnTrueSizeX "New Size X:" pos:[30,chkX.pos.y] range:[1,1000,100] enabled:chkX.checked
	
	checkbox chkResetXForm "ResetX-Form?" pos:[5,chkX.pos.y+20] checked:true
	checkbox chkPivotZ "Move Pivot to z: 0?" pos:[5,chkX.pos.y+40] checked:true
	checkbox chkPivotZero "Move Obj to [0,0,0]?" pos:[5,chkX.pos.y+60] checked:true
	checkbox chkPivotCenter "Center Pivot XY?" pos:[5,chkX.pos.y+80] checked:false tooltip:"Just for \"Do not Scale/Move it ...\"-Button!"
	
	button btnDontScale "Do not Scale/Move it ..." pos:[5,chkPivotCenter.pos.y+30] tooltip:"JUST A TEST BUTTON!!!"
	
	button btnPlusTen "Scale*10" pos:[5,chkPivotCenter.pos.y+55]
	button btnMinusTen  "Scale/10" pos:[65,chkPivotCenter.pos.y+55]
	
	button btnUpdate "Update" pos:[5,chkPivotCenter.pos.y+80] tooltip:"Updates \"CurrentSize\""
	button btnApply "Apply" pos:[65,chkPivotCenter.pos.y+80] tooltip:"If you press Apply, your selected Mesh will get\nresized, ResetX-Form, and put to 0,0,0\nYou CAN NOT UNDO IT!"
	button btnCancel "Cancel" pos:[115,chkPivotCenter.pos.y+80]
	
	on ResizeAfterZBrush open do
	(
		fn UpdateTheMesh =
		(
			TheMesh.obj = $
			try(
				TheMesh.height = (TheMesh.obj.min.z - TheMesh.obj.max.z)*-1
				TheMesh.width = (TheMesh.obj.min.x - TheMesh.obj.max.x)*-1
				TheMesh.depth = (TheMesh.obj.min.y - TheMesh.obj.max.y)*-1
				
				lblText.caption = "Current Obj: " + (TheMesh.obj.name as string)
				if chkZ.checked == true then
				(
					lblCurrentSize.caption = "Current size: " + (TheMesh.height as string) + " cm"
				)
				else
				(
					if chkY.checked == true then
					(
						lblCurrentSize.caption = "Current size: " + (TheMesh.depth as string) + " cm"
					)
					else
					(
						lblCurrentSize.caption = "Current size: " + (TheMesh.width as string) + " cm"
					)
				)
			)catch()
		)
		UpdateTheMesh()
	)
	on btnUpdate pressed do
	(
		UpdateTheMesh()
	)
	on chkZ changed state do
	(
		spnTrueSizeZ.enabled = state
		if state == true then
		(
			spnTrueSizeX.enabled = not state
			chkX.checked = not state
			spnTrueSizeY.enabled = not state
			chkY.checked = not state
		)
		else
		(
			chkZ.checked = not state
			spnTrueSizeZ.enabled = not state
		)
		UpdateTheMesh()
	)
	on chkY changed state do
	(
		spnTrueSizeY.enabled = state
		if state == true then
		(
			spnTrueSizeZ.enabled = not state
			chkZ.checked = not state
			spnTrueSizeX.enabled = not state
			chkX.checked = not state
		)
		else
		(
			chkY.checked = not state
			spnTrueSizeY.enabled = not state
		)
		UpdateTheMesh()
	)
	on chkX changed state do
	(
		spnTrueSizeX.enabled = state
		if state == true then
		(
			spnTrueSizeZ.enabled = not state
			chkZ.checked = not state
			spnTrueSizeY.enabled = not state
			chkY.checked = not state
		)
		else
		(
			chkX.checked = not state
			spnTrueSizeX.enabled = not state
		)
		UpdateTheMesh()
	)
	
	on btnApply pressed do
	(
		UpdateTheMesh()
		
		if queryBox "Are you sure you want to continue?\nI mean, you can't undo it ...\nCould crash everything!\nBecause of ResetX-Form ...\nIt's your choice ...\nGood luck ..." do
		(
			if chkZ.checked == true do
			(
				local Dif
				Dif = spnTrueSizeZ.value as float / TheMesh.height as float
				TheMesh.obj.scale = [Dif,Dif,Dif]
				
				if chkPivotZ.checked == true do
				(
					TheMesh.obj.pos.z -= TheMesh.obj.min.z
					TheMesh.obj.pivot.z = 0
				)
				
				if chkPivotZero.checked == true do
				(
					TheMesh.obj.pos = [0,0,0]
				)
				
				if chkResetXForm.checked == true do
				(
					ResetXForm TheMesh.obj
					collapsestack TheMesh.obj
				)
				
				UpdateTheMesh()
			)
			if chkY.checked == true do
			(
				local Dif
				Dif = spnTrueSizeY.value as float / TheMesh.depth as float
				TheMesh.obj.scale = [Dif,Dif,Dif]
				
				if chkPivotZ.checked == true do
				(
					TheMesh.obj.pos.z -= TheMesh.obj.min.z
					TheMesh.obj.pivot.z = 0
				)
				
				if chkPivotZero.checked == true do
				(
					TheMesh.obj.pos = [0,0,0]
				)
				
				if chkResetXForm.checked == true do
				(
					ResetXForm TheMesh.obj
					collapsestack TheMesh.obj
				)
				
				UpdateTheMesh()
			)
			if chkX.checked == true do
			(
				local Dif
				Dif = spnTrueSizeX.value as float / TheMesh.width as float
				TheMesh.obj.scale = [Dif,Dif,Dif]
				
				if chkPivotZ.checked == true do
				(
					TheMesh.obj.pos.z -= TheMesh.obj.min.z
					TheMesh.obj.pivot.z = 0
				)
				
				if chkPivotZero.checked == true do
				(
					TheMesh.obj.pos = [0,0,0]
				)
				
				if chkResetXForm.checked == true do
				(
					ResetXForm TheMesh.obj
					collapsestack TheMesh.obj
				)
				
				UpdateTheMesh()
			)
		)
	)
	
	on btnDontScale pressed do
	(
		UpdateTheMesh()
		
		if queryBox "Are you sure you want to continue?\nI mean, you can't undo it ...\nCould crash everything!\nBecause of ResetX-Form ...\nIt's your choice ...\nGood luck ..." do
		(
			if chkPivotCenter.checked == true do
			(
				local Z = TheMesh.obj.pivot.z
				CenterPivot TheMesh.obj
				TheMesh.obj.pivot.z = Z
			)
			
			if chkPivotZ.checked == true do
			(
				TheMesh.obj.pos.z -= TheMesh.obj.min.z
				TheMesh.obj.pivot.z = 0
			)
			
			if chkPivotZero.checked == true do
			(
				TheMesh.obj.pos = [0,0,0]
			)
			
			if chkResetXForm.checked == true do
			(
				ResetXForm TheMesh.obj
				collapsestack TheMesh.obj
			)
			
			UpdateTheMesh()
		)
	)
	
	on btnMinusTen pressed do
	(
		$.scale /= 10
	)
	on btnPlusTen pressed do
	(
		$.scale *= 10
	)
	
	on btnCancel pressed do
	(
		destroydialog ResizeAfterZBrush
	)
)
createdialog ResizeAfterZBrush pos:[300,300]